Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/DirectoryHelper.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/DirectoryHelper.java	(revision 28682)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/DirectoryHelper.java	(working copy)
@@ -166,36 +280,531 @@
      */
     public static String getUrlExistsQuery(String siteName, String language, String url)
     {
-        String lowerUrl = StringUtils.replace(url, "'", "''").toLowerCase();
-        return getLinksNodePath(siteName, language) + "/element(*, " + DefaultLinkFactory.LINK_NODE_TYPE + ")[fn:lower-case(@ametys-internal:url) = '" + lowerUrl + "']";
+        String lowerCaseUrl = StringUtils.replace(url, "'", "''").toLowerCase();
+        return getLinksNodePath(siteName, language) + "/element(*, " + DefaultLinkFactory.LINK_NODE_TYPE + ")[fn:lower-case(@ametys-internal:url) = '" + lowerCaseUrl + "']";
     }
     
     /**
-     * Get the word definitions storage node.
+     * Get the query verifying the existence of a theme
      * @param siteName the site name.
      * @param language the language.
-     * @param label the label to test. 
+     * @param label the label of the theme to test. 
      * @return the word definitions storage node.
      */
     public static String getThemeExistsQuery(String siteName, String language, String label)
     {
-        String lowerLabel = StringUtils.replace(label, "'", "''").toLowerCase();
-        return getThemesNodePath(siteName, language) + "/element(*, " + DefaultThemeFactory.THEME_NODE_TYPE + ")[fn:lower-case(@ametys-internal:label) = '" + lowerLabel + "']";
+        String lowerCaseLabel = StringUtils.replace(label, "'", "''").toLowerCase();
+        return getThemesNodePath(siteName, language) + "/element(*, " + DefaultThemeFactory.THEME_NODE_TYPE + ")[fn:lower-case(@ametys-internal:label) = '" + lowerCaseLabel + "']";
+    }
+    
+    /**
+     * Normalizes an input string in order to capitalize it, remove accents, and replace whitespaces with underscores
+     * @param s the string to normalize
+     * @return the normalized string
+     */
+    public static String normalizeString(String s)
+    {
+        // Upper case
+        String upperCaseLabel = s.replaceAll(" ", "_").toUpperCase();
+        
+        // Strip accents
+        String normalizedLabel = Normalizer.normalize(upperCaseLabel, Normalizer.Form.NFD).replaceAll("[^\\p{ASCII}]", "");
+        
+        return normalizedLabel;
+    }
+    
+    /**
+     * Get the list of links corresponding to the given theme ids
+     * @param themesIds the ids of the configured themes
+     * @param login the login of the current user
+     * @param siteName the site's name
+     * @param language the site's language
+     * @return the list of default links corresponding to the given themes
+     */
+    public static List<DefaultLink> getLinks(List<String> themesIds, String login, String siteName, String language)
+    {
+        if (themesIds.isEmpty())
+        {
+            Site site = _siteManager.getSite(siteName);
+            TraversableAmetysObject linksNode = DirectoryHelper.getLinksNode(site, language);
+            AmetysObjectIterable<AmetysObject> links = linksNode.getChildren();
+            return IteratorUtils.toList(links);
+        }
+        else
+        {
+            int configuredThemeIdsSize = themesIds.size();
+            
+            Expression[] expressions = new Expression[configuredThemeIdsSize];
+            for (int i = 0; i < themesIds.size(); i++)
+            {
+                expressions[i] = new ThemeExpression(themesIds.get(i));
+            }
+            
+            String xPathQuery = getLinksQuery(siteName, language, new OrExpression(expressions));
+            AmetysObjectIterable<AmetysObject> configuredThemeLinks = _ametysObjectResolver.query(xPathQuery);
+            
+            return IteratorUtils.toList(configuredThemeLinks);
+        }
+    }
+    
+    /**
+     * Checks if the links displayed in a link directory service has access restrictions
+     * @param siteName the name of the site
+     * @param language the language
+     * @param themesIds the list of selected theme ids
+     * @return true if the links of the service have access restrictions, false otherwise
+     */
+    public static boolean hasRestrictions(String siteName, String language, List<String> themesIds)
+    {
+        AmetysObjectIterable<AmetysObject> links = null;
+        
+        // No themes => we check all the links' access restrictions
+        if (themesIds.isEmpty())   
+        {
+            String allLinksQuery = getAllLinksQuery(siteName, language);
+            links = _ametysObjectResolver.query(allLinksQuery);
+            
+            if (isAccessRestricted(links))
+            {
+                return true;
+            }
+        }
+        // The service has themes specified => we solely check the corresponding links' access restrictions
+        else
+        {
+            for (String themeId : themesIds)
+            {
+                String xPathQuery = getLinksQuery(siteName, language, new ThemeExpression(themeId));
+                links = _ametysObjectResolver.query(xPathQuery);
+                
+                if (isAccessRestricted(links))
+                {
+                    return true;
+                }
+            }
+        }
+        
+        // All the tested links have no restricted access
+        return false;
+    }
+    
+    /**
+     * Check if the links' access is restricted or not
+     * @param links the links to be tested
+     * @return true if the link has a restricted access, false otherwise
+     */
+    public static boolean isAccessRestricted(AmetysObjectIterable<AmetysObject> links)
+    {
+        while (links.hasNext())
+        {
+            DefaultLink link = (DefaultLink) links.next();
+            
+            // If any of the links has a limited access, the service declares itself non-cacheable
+            if (link.isAllowedAnyUser() || ArrayUtils.isNotEmpty(link.getGrantedGroups()) || ArrayUtils.isNotEmpty(link.getGrantedUsers()))
+            {
+                return false;
+            }
+        }
+        
+        return true;
     }
     
     private static ModifiableTraversableAmetysObject getOrCreateNode(ModifiableTraversableAmetysObject parentNode, String nodeName, String nodeType) throws AmetysRepositoryException
     {
-        ModifiableTraversableAmetysObject definitionsNode;
+        ModifiableTraversableAmetysObject node;
         if (parentNode.hasChild(nodeName))
         {
-            definitionsNode = parentNode.getChild(nodeName);
+            node = parentNode.getChild(nodeName);
         }
         else
         {
-            definitionsNode = parentNode.createChild(nodeName, nodeType);
+            node = parentNode.createChild(nodeName, nodeType);
             parentNode.saveChanges();
         }
-        return definitionsNode;
+        return node;
+    }
+    
+    /**
+     * Sax the directory links
+     * @param contentHandler the content handler
+     * @param links the list of links to sax 
+     * @param storageContext the storage context, null if there is no connected user
+     * @param contextVars the context variables
+     * @param login the login of the user
+     * @param saxThemesLabelOnly true to sax themes label only
+     * @param saxLinksOnly true if the only the links need to be saxed, false otherwise
+     * @throws SAXException If an error occurs while generating the SAX events
+     * @throws UserPreferencesException if an exception occurs while getting the user preferences
+     */
+    public static void saxLinks(ContentHandler contentHandler, List<DefaultLink> links, Map<String, String> contextVars, String storageContext, String login, boolean saxThemesLabelOnly, boolean saxLinksOnly) throws SAXException, UserPreferencesException
+    {
+        String prefValues = null;
+        String[] prefLinksIdsArray = null; 
+        if (login != null)
+        {
+            prefValues =  _userPreferencesManager.getUserPreferenceAsString(login, storageContext, contextVars, "checked-links");
+            prefLinksIdsArray = StringUtils.split(prefValues, ",");
+        }
+            
+        for (DefaultLink link : links)
+        {
+            if (_isCurrentUserGrantedAccess(link))
+            {
+                boolean selected = false;
+                if (ArrayUtils.isNotEmpty(prefLinksIdsArray))
+                {
+                    if (ArrayUtils.contains(prefLinksIdsArray, link.getId()))
+                    {
+                        selected = true;
+                    }
+                }
+                
+                saxLink(contentHandler, link, saxThemesLabelOnly, selected, saxLinksOnly);
+            }
+        }
+    }
+    
+    /**
+     * Generate a directory link.
+     * @param contentHandler the content handler
+     * @param link the link to generate.
+     * @param saxThemesLabelOnly true to sax themes label only
+     * @param selected true if a front end user has checked this link as a user preference, false otherwise
+     * @param saxLinksOnly true if we want to sax a link for an input data
+     * @throws SAXException If an error occurs while generating the SAX events
+     */
+    public static void saxLink (ContentHandler contentHandler, DefaultLink link, boolean saxThemesLabelOnly, boolean selected, boolean saxLinksOnly) throws SAXException
+    {
+        AttributesImpl attrs = new AttributesImpl();
+        attrs.addCDATAAttribute("id", link.getId());
+        
+        attrs.addCDATAAttribute("url", StringUtils.defaultString(link.getUrl()));
+        attrs.addCDATAAttribute("title", StringUtils.defaultString(link.getTitle()));
+        attrs.addCDATAAttribute("content", StringUtils.defaultString(link.getContent()));
+        
+        attrs.addCDATAAttribute("alternative", StringUtils.defaultString(link.getAlternative()));
+        attrs.addCDATAAttribute("pictureAlternative", StringUtils.defaultString(link.getPictureAlternative()));
+        
+        attrs.addCDATAAttribute("user-selected", selected ? "true" : "false");
+        
+        String pictureType = link.getPictureType();
+        attrs.addCDATAAttribute("pictureType", pictureType);
+        if (pictureType.equals("resource"))
+        {
+            String resourceId = link.getResourcePictureId();
+            Resource resource = _ametysObjectResolver.resolveById(resourceId);
+            attrs.addCDATAAttribute("pictureId", resourceId);
+            attrs.addCDATAAttribute("pictureName", resource.getName());
+            attrs.addCDATAAttribute("pictureSize", Long.toString(resource.getLength()));
+            attrs.addCDATAAttribute("imageType", "explorer");
+        }
+        else if (pictureType.equals("external"))
+        {
+            BinaryMetadata picMeta = link.getExternalPicture();
+            attrs.addCDATAAttribute("picturePath", DefaultLink.METADATA_PICTURE);
+            attrs.addCDATAAttribute("pictureName", picMeta.getFilename());
+            attrs.addCDATAAttribute("pictureSize", Long.toString(picMeta.getLength()));
+            attrs.addCDATAAttribute("imageType", "metadata");
+        }
+        
+        attrs.addCDATAAttribute("grantAnyUser", String.valueOf(link.isAllowedAnyUser()));
+        
+        boolean isAccessLimited = link.isAllowedAnyUser() || ArrayUtils.isNotEmpty(link.getGrantedUsers()) || ArrayUtils.isNotEmpty(link.getGrantedGroups());
+        String isAccessLimitedStr = isAccessLimited ? _i18nUtils.translate(new I18nizableText("plugin.link-directory", "PLUGINS_LINKDIRECTORY_UITOOL_LIMITED_ACCESS_YES"))
+                                                    : _i18nUtils.translate(new I18nizableText("plugin.link-directory", "PLUGINS_LINKDIRECTORY_UITOOL_LIMITED_ACCESS_NO"));
+        
+        attrs.addCDATAAttribute("limitedAccess", isAccessLimitedStr); 
+        
+        XMLUtils.startElement(contentHandler, "link", attrs);
+
+        // Sax the access limitations if necessary
+        if (!saxLinksOnly)
+        {
+            _saxGrantedUsers(contentHandler, link);
+            _saxGrantedGroups(contentHandler, link);
+        }
+        
+        // Themes
+        if (saxThemesLabelOnly)
+        {
+            _saxThemesLabel(contentHandler, link);
+        }
+        else
+        {
+            _saxThemes(contentHandler, link);
+        }
+        
+        XMLUtils.endElement(contentHandler, "link");
     }
     
+    /**
+     * Get the actual ids of the configured themes
+     * @param configuredThemesNames the normalized ids of the configured themes
+     * @param siteName the site's name
+     * @param language the site's language
+     * @return the actual ids of the configured themes
+     */
+    public static Map<String, List<String>> getThemesMap(List<String> configuredThemesNames, String siteName, String language)
+    {
+        Map<String, List<String>> themesMap = new HashMap<String, List<String>> ();
+        List<String> correctThemesList = new ArrayList<String> ();
+        List<String> wrongThemesList = new ArrayList<String> ();
+        
+        for (int i = 0; i < configuredThemesNames.size(); i++)
+        {
+            ModifiableTraversableAmetysObject themesNode = DirectoryHelper.getThemesNode(_siteManager.getSite(siteName), language);
+            String configuredThemeName = configuredThemesNames.get(i);
+            
+            if (!themesNode.hasChild(configuredThemeName))
+            {
+                _logger.warn("The theme '" + configuredThemeName + "' was not found. It will be ignored.");
+                wrongThemesList.add(configuredThemeName);
+            }
+            else
+            {
+                AmetysObject configuredThemeNode = themesNode.getChild(configuredThemesNames.get(i));
+                correctThemesList.add(configuredThemeNode.getId());
+            }
+        }
+        
+        themesMap.put("correct-themes", correctThemesList);
+        themesMap.put("wrong-themes", wrongThemesList);
+        return themesMap;
+    }
+    
+    /**
+     * Verify the existence of a theme
+     * @param siteName the site's name
+     * @param language the site's language
+     * @param expression 
+     * @return true if the theme exists, false otherwise
+     */
+    public static boolean themeExists(String siteName, String language, Expression expression)
+    {
+        String xPathQuery = getThemeQuery(siteName, language, expression);
+        AmetysObjectIterable<AmetysObject> theme = _ametysObjectResolver.query(xPathQuery);
+        
+        return theme.hasNext();
+    }
+
+    /**
+     * Get the site's name
+     * @param request the request
+     * @return the site's name
+     */
+    public static String getSiteName(Request request)
+    {
+        Page page = (Page) request.getAttribute(Page.class.getName());
+        String siteName = null;
+        if (page != null)
+        {
+            siteName = page.getSiteName();
+        }
+        else
+        {
+            siteName = (String) request.getAttribute("site");
+        }
+        return siteName;
+    }
+
+    /**
+     * Get the site's language
+     * @param request the request
+     * @return the site's language
+     */
+    public static String getLanguage(Request request)
+    {
+        String language = (String) request.getAttribute("sitemapLanguage");
+        if (StringUtils.isEmpty(language))
+        {
+            language = request.getParameter("language");
+        }
+        
+        return language;
+    }
+    
+    /**
+     * Retrieve the context variables from the front
+     * @param request the request
+     * @return the map of context variables
+     */
+    public static Map<String, String> getContextVars(Request request)
+    {
+        Map<String, String> contextVars = new HashMap<String, String> ();
+        
+        contextVars.put(FOUserPreferencesConstants.CONTEXT_VAR_SITENAME, getSiteName(request));
+        contextVars.put(FOUserPreferencesConstants.CONTEXT_VAR_LANGUAGE, getLanguage(request));
+    
+        return contextVars;
+    }
+    
+    /**
+     * Sax the themes
+     * @param contentHandler the content handler 
+     * @param link the link 
+     * @throws SAXException If an error occurs while generating the SAX events
+     */
+    private static void _saxThemes (ContentHandler contentHandler, DefaultLink link) throws SAXException
+    {
+        XMLUtils.startElement(contentHandler, "themes");
+        
+        for (String themeId : link.getThemes())
+        {
+            try
+            {
+                DefaultTheme theme = _ametysObjectResolver.resolveById(themeId);
+                
+                AttributesImpl attrs = new AttributesImpl();
+                attrs.addCDATAAttribute("id", themeId);
+                attrs.addCDATAAttribute("label", theme.getLabel());
+                
+                XMLUtils.createElement(contentHandler, "theme", attrs);
+            }
+            catch (UnknownAmetysObjectException e)
+            {
+                // Theme does not exist anymore
+            }
+        }
+            
+        
+        XMLUtils.endElement(contentHandler, "themes");
+    }
+    
+    /**
+     * Sax the label of the themes
+     * @param contentHandler
+     * @param link
+     * @throws SAXException
+     */
+    private static void _saxThemesLabel (ContentHandler contentHandler, DefaultLink link) throws SAXException
+    {
+        List<String> themesLabel = new ArrayList<String>();
+        
+        for (String themeId : link.getThemes())
+        {
+            try
+            {
+                DefaultTheme theme = _ametysObjectResolver.resolveById(themeId);
+                themesLabel.add(theme.getLabel());
+            }
+            catch (UnknownAmetysObjectException e)
+            {
+                // Theme does not exist anymore
+            }
+        }
+        
+        XMLUtils.createElement(contentHandler, "themes", StringUtils.join(themesLabel, ", "));
+    }
+    
+    /**
+     * Sax the granted users
+     * @param contentHandler
+     * @param link
+     * @throws SAXException
+     */
+    private static void _saxGrantedUsers(ContentHandler contentHandler, DefaultLink link) throws SAXException
+    {
+        XMLUtils.startElement(contentHandler, "granted-users");
+        
+        for (String grantedUser : link.getGrantedUsers())
+        {
+            User user = _usersManager.getUser(grantedUser);
+            if (user != null)
+            {
+                AttributesImpl attrs = new AttributesImpl();
+                attrs.addCDATAAttribute("login", grantedUser);
+                attrs.addCDATAAttribute("fullName", user.getFullName());
+                XMLUtils.createElement(contentHandler, "granted-user", attrs);
+            }
+        }
+        XMLUtils.endElement(contentHandler, "granted-users");
+    }
+    
+    /**
+     * Sax the granted groups
+     * @param contentHandler
+     * @param link
+     * @throws SAXException
+     */
+    private static void _saxGrantedGroups(ContentHandler contentHandler, DefaultLink link) throws SAXException
+    {
+        XMLUtils.startElement(contentHandler, "granted-groups");
+        
+        for (String grantedGroupId : link.getGrantedGroups())
+        {
+            AttributesImpl attrs = new AttributesImpl();
+            attrs.addCDATAAttribute("id", grantedGroupId);
+            attrs.addCDATAAttribute("label", _groupsManager.getGroup(grantedGroupId).getLabel());
+            XMLUtils.createElement(contentHandler, "granted-group", attrs);
+
+        }
+        XMLUtils.endElement(contentHandler, "granted-groups");
+    }
+    
+    /**
+     * Determines if the current user is allowed to see the link or not
+     * @param link the link 
+     * @return true if the current user is allowed to see the link, false otherwise
+     */
+    private static boolean _isCurrentUserGrantedAccess(DefaultLink link)
+    {
+        RenderingContext renderingContext = _renderingContextHandler.getRenderingContext();
+        
+        // Any user can see all the links in the back-office or in preview mode regardless of the access limitations
+        if (!renderingContext.equals(RenderingContext.FRONT))
+        {
+            return true;
+        }
+        
+        Request request = ContextHelper.getRequest(_context);
+        String login = (String) request.getAttribute(WebConstants.FO_LOGIN);
+        
+        boolean isAllowedAnyUser = link.isAllowedAnyUser();
+        String[] grantedUsers = link.getGrantedUsers();
+        String[] grantedGroups = link.getGrantedGroups();
+        
+        // There is an access restriction on users or groups
+        if (ArrayUtils.isNotEmpty(grantedUsers) || ArrayUtils.isNotEmpty(grantedGroups))
+        {
+            return _isGrantedAccess(login, grantedUsers, grantedGroups);
+        }
+        
+        // There is an access restriction on connected users
+        if (isAllowedAnyUser)
+        {
+            return login != null ? true : false;
+        }
+        
+        // There is no access restriction
+        return true;
+    }
+    
+    /**
+     * Checks if the user has access to the page or not
+     * @param login the login of the user
+     * @param grantedUsers the list of granted users
+     * @param grantedGroups the list of granted groups
+     * @return true if the user is granted access, false otherwise
+     */
+    private static boolean _isGrantedAccess(String login, String[] grantedUsers, String[] grantedGroups)
+    {
+        Set<String> groups  = _groupsManager.getUserGroups(login);  
+
+        // Check the authorizations
+        if (ArrayUtils.contains(grantedUsers, login))
+        {
+            return true;
+        }
+        
+        for (String groupId : grantedGroups)
+        {
+            if (groups.contains(groupId))
+            {
+                return true;
+            }
+        }
+        
+        // The user doesn't belong to the granted users
+        return false;
+    }
 }
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/Link.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/Link.java	(revision 28682)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/Link.java	(working copy)
@@ -17,15 +17,21 @@
 
 import java.io.InputStream;
 
+import javax.jcr.Node;
+import javax.jcr.RepositoryException;
+
+import org.apache.commons.lang.StringUtils;
+
+import org.ametys.plugins.repository.AmetysObject;
 import org.ametys.plugins.repository.AmetysRepositoryException;
 import org.ametys.plugins.repository.metadata.BinaryMetadata;
+import org.ametys.web.alias.DefaultAlias;
 
 /**
  * A link in the directory.
  */
 public interface Link
 {
-    
     /**
      * Get the URL.
      * @return the link URL.
@@ -147,7 +153,7 @@
     public void setPictureAlternative(String alternative) throws AmetysRepositoryException;
     
     /**
-     * Set the themes.
+     * Get the themes.
      * @return the themes in an Array
      * @throws AmetysRepositoryException if an error occurs.
      */
@@ -163,7 +169,49 @@
     /**
      * Remove theme if exist
      * @param themeId The id of theme to remove 
-     * @throws AmetysRepositoryException if an error occured
+     * @throws AmetysRepositoryException if an error occurs
      */
     public void removeTheme (String themeId) throws AmetysRepositoryException;
+    
+    /**
+     * Get the list of granted users
+     * @return the users who  have access to this link
+     * @throws AmetysRepositoryException if an error occurs
+     */
+    public String[] getGrantedUsers() throws AmetysRepositoryException;
+
+    /**
+     * Set the list of granted users
+     * @param grantedUsers the users who will have access to this link
+     * @throws AmetysRepositoryException if an error occurs
+     */
+    public void setGrantedUsers(String[] grantedUsers) throws AmetysRepositoryException;
+    
+    /**
+     * Get the list of granted groups
+     * @return excludedGroups the groups who don't have access to this link
+     * @throws AmetysRepositoryException if an error occurs
+     */
+    public String[] getGrantedGroups() throws AmetysRepositoryException;
+    
+    /**
+     * Set the list of granted groups 
+     * @param grantedGroups the groups who will have access to this link
+     * @throws AmetysRepositoryException if an exception occurs
+     */
+    public void setGrantedGroups(String[] grantedGroups) throws AmetysRepositoryException;
+    
+    /**
+     * Is any connected user allowed ?
+     * @return true if every connected user is allowed, false otherwise
+     * @throws AmetysRepositoryException if an exceptions occurs
+     */
+    public boolean isAllowedAnyUser() throws AmetysRepositoryException;
+    
+    /**
+     * Determines if any connected user will be granted access to this link, depending on the parameter's value
+     * @param allowAnyUser "true" to allow any connected user, "false" otherwise
+     * @throws AmetysRepositoryException
+     */
+    public void setGrantAnyUser(boolean allowAnyUser) throws AmetysRepositoryException;
 }
